/*************************************************************************
Title:    1-wire Dallas DS1990A (i-button) to LCD display.
Author: Savel  
Lietuviskas: Savel. www.savel.org / levas.vabolis.com

**************************************************************************/

#define XTAL 12000000L
#define F_OSC 12000000L
/* see also makefile */


#include <stdlib.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <util\delay.h>

#include "lcd.h"
#include "lcd.c"
#include "onewire.c"
#include "crc8.c"

//print

void print(uint8_t i)
{
char buffer[3]; /* SVARBU! 3 baitai min */

itoa( i, buffer, 16);
		if (i<16) {lcd_putc('0');}
		lcd_puts(buffer);
}

/*******************************************************/


int main(void)
{
    uint8_t  num;
    uint8_t i;
	uint8_t idd[9];
    
 
    /* initialize display, cursor off */
    lcd_init(LCD_DISP_ON);

    for (;;) {                           /* loop forever */
			lcd_clrscr();
			lcd_puts("ST:");
			num=ow_reset(); 
			
				switch (num) {
					case 8:
						lcd_puts("OPEN ");
						break;
					case 1:
						lcd_puts("SHORT");
						break;
					case 0:
						lcd_puts("OK   ");
						break;
					default:
						lcd_puts("ERROR");
					}
						
			lcd_puts(" CRC:");
	
	//ow_command(0x33, 0);
	ow_byte_wr(0x33);
	for ( i=0 ; i< 8; i++ ) {idd[i]=ow_byte_rd();}
	
	lcd_gotoxy(13,0);
	print(idd[7]); //crc
	
	lcd_gotoxy(0,1);
	print(idd[0]); //device family id
	
	lcd_gotoxy(3,1);
	for (i=6; i>0; i--)
	{
		
		print(idd[i]);
	}

	/*if ( crc8( &idd[0], 8 ) ) {lcd_gotoxy(5,0); lcd_puts("CRC");} */
	/* still not working :) */

		for(i=0; i<100; i++) {
				_delay_ms(20);} // pauzike, kad pernelyg greitai nesikeistu skaiciukai.
			
		
    }
}


